import { getRechargeList } from "../../service/recharge";
import { getOwnTenementList } from "../../service/tenement";
import { getYears, alertInfo } from "../../utils/index";
import request from "../../utils/request";
const { OK } = request;
// pages/rechargeRecord/index.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    year: new Date().getFullYear(),
    month: new Date().getMonth() + 1,
    years: getYears(),
    list: [

    ],
    tenement: "",
    tenementName: "",
    show: false,
    columns: [],
    type: "",
    title: "",
    amount: 0,
  },
  clickYear() {
    this.setData({
      type: "year",
      columns: this.data.years,
      show: true,
      title: "年份"
    })
  },
  clickTenement() {
    this.setData({
      type: "tenement",
      columns: this.data.tenements,
      show: true,
      title: "商户"
    })
  },
  onOk(e) {
    const { type, value = {} } = e.detail;
    if (type === "year") {
      this.onChangeYear(value.id)
      return;
    }
    if (type === "tenement") {
      this.onChangeTenement(value.id)
      return;
    }
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },
  onChangeYear(e) {
    const { years, tenement } = this.data;
    const currentYear = years[Number(e)]
    this.setData({
      year: currentYear,
      type: "",
      show: false,
      title: ""
    })
    this.init(currentYear, tenement)
  },
  onChangeTenement(e) {
    const { year } = this.data;
    // const currentYear = years[Number(e)]
    this.setData({
      // year: currentYear,
      tenement: e, 
      type: "",
      show: false,
      title: ""
    })
    this.init(year, e)
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    const { year, tenement } = this.data;
    this.init(year, tenement);
    this.getTenementsList();
  },
  async getTenementsList() {
    const { code, message, data } = await getOwnTenementList()
    if (code !== OK) {
      alertInfo(message)
      return
    }
    let tenements = [];
    data.forEach(item => {
      if (item.tenements) {
        tenements = [...tenements, ...item.tenements]
      }
    })
    this.setData({ tenements })
  },
  async init(year, tenement) {
    const { code, message, data = [], amount = 0 } = await getRechargeList(year, tenement);
    this.setData({
      list: data,
      amount
    })
  },
  onCancel() {
    this.setData({
      show: false,
      title: "",
      type: "",
    })
  },
  jumpToDetail(e) {
    const { id } = e.currentTarget.dataset;
    wx.navigateTo({
      url: '/pages/rechargeDetail/index?id=' + id,
    })
  },
  back() {
    wx.navigateBack({delta: 1  })
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})